/**
 */
package de.upb.swt.swtpra2017.swtinterface.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.eclipse.emf.ecore.xml.type.XMLTypePackage;

import de.upb.swt.swtpra2017.swtinterface.ClientRole;
import de.upb.swt.swtpra2017.swtinterface.Configuration;
import de.upb.swt.swtpra2017.swtinterface.FinishedNotification;
import de.upb.swt.swtpra2017.swtinterface.FinishedReason;
import de.upb.swt.swtpra2017.swtinterface.Game;
import de.upb.swt.swtpra2017.swtinterface.GameContinueNotification;
import de.upb.swt.swtpra2017.swtinterface.GameJoinRequest;
import de.upb.swt.swtpra2017.swtinterface.GameListRequest;
import de.upb.swt.swtpra2017.swtinterface.GameListResponse;
import de.upb.swt.swtpra2017.swtinterface.GamePauseNotification;
import de.upb.swt.swtpra2017.swtinterface.GameStartNotification;
import de.upb.swt.swtpra2017.swtinterface.GameState;
import de.upb.swt.swtpra2017.swtinterface.GameStateNotification;
import de.upb.swt.swtpra2017.swtinterface.Gate;
import de.upb.swt.swtpra2017.swtinterface.JoinResponse;
import de.upb.swt.swtpra2017.swtinterface.KickNotification;
import de.upb.swt.swtpra2017.swtinterface.KickReason;
import de.upb.swt.swtpra2017.swtinterface.Placement;
import de.upb.swt.swtpra2017.swtinterface.Player;
import de.upb.swt.swtpra2017.swtinterface.Position;
import de.upb.swt.swtpra2017.swtinterface.ProcessingRequestReply;
import de.upb.swt.swtpra2017.swtinterface.Rotation;
import de.upb.swt.swtpra2017.swtinterface.SetTileCmd;
import de.upb.swt.swtpra2017.swtinterface.SetTokenCmd;
import de.upb.swt.swtpra2017.swtinterface.Tile;
import de.upb.swt.swtpra2017.swtinterface.Token;
import de.upb.swt.swtpra2017.swtinterface.Tsuro_InterfaceFactory;
import de.upb.swt.swtpra2017.swtinterface.Tsuro_InterfacePackage;
import de.upb.swt.swtpra2017.swtinterface.TurnNotification;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class Tsuro_InterfacePackageImpl extends EPackageImpl implements Tsuro_InterfacePackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass turnNotificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass kickNotificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass gameStateNotificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass positionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tileEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass playerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass setTokenCmdEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tokenEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass finishedNotificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass configurationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass gameEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass setTileCmdEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass gameListRequestEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass gameListResponseEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass gameJoinRequestEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass gameStartNotificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass gamePauseNotificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass gameContinueNotificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass placementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass processingRequestReplyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum kickReasonEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum rotationEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum finishedReasonEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum gateEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum gameStateEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum clientRoleEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum joinResponseEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see de.upb.swt.swtpra2017.swtinterface.Tsuro_InterfacePackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private Tsuro_InterfacePackageImpl() {
		super(eNS_URI, Tsuro_InterfaceFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link Tsuro_InterfacePackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static Tsuro_InterfacePackage init() {
		if (isInited) return (Tsuro_InterfacePackage)EPackage.Registry.INSTANCE.getEPackage(Tsuro_InterfacePackage.eNS_URI);

		// Obtain or create and register package
		Tsuro_InterfacePackageImpl theTsuro_InterfacePackage = (Tsuro_InterfacePackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof Tsuro_InterfacePackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new Tsuro_InterfacePackageImpl());

		isInited = true;

		// Initialize simple dependencies
		XMLTypePackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theTsuro_InterfacePackage.createPackageContents();

		// Initialize created meta-data
		theTsuro_InterfacePackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theTsuro_InterfacePackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(Tsuro_InterfacePackage.eNS_URI, theTsuro_InterfacePackage);
		return theTsuro_InterfacePackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTurnNotification() {
		return turnNotificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTurnNotification_SetToken() {
		return (EAttribute)turnNotificationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTurnNotification_Player() {
		return (EReference)turnNotificationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getKickNotification() {
		return kickNotificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getKickNotification_Reason() {
		return (EAttribute)kickNotificationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getKickNotification_Players() {
		return (EReference)kickNotificationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGameStateNotification() {
		return gameStateNotificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGameStateNotification_TurnPlayer() {
		return (EReference)gameStateNotificationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGameStateNotification_CurrentRoundNo() {
		return (EAttribute)gameStateNotificationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGameStateNotification_TimePassed() {
		return (EAttribute)gameStateNotificationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGameStateNotification_Game() {
		return (EReference)gameStateNotificationEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGameStateNotification_NextTilePosition() {
		return (EReference)gameStateNotificationEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGameStateNotification_Placements() {
		return (EReference)gameStateNotificationEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPosition() {
		return positionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPosition_X() {
		return (EAttribute)positionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPosition_Y() {
		return (EAttribute)positionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTile() {
		return tileEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTile_TileId() {
		return (EAttribute)tileEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPlayer() {
		return playerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPlayer_Name() {
		return (EAttribute)playerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPlayer_IsAI() {
		return (EAttribute)playerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPlayer_Position() {
		return (EReference)playerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPlayer_ClientId() {
		return (EAttribute)playerEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPlayer_TileList() {
		return (EReference)playerEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPlayer_InGame() {
		return (EAttribute)playerEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSetTokenCmd() {
		return setTokenCmdEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSetTokenCmd_Gate() {
		return (EAttribute)setTokenCmdEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getToken() {
		return tokenEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getToken_Gate() {
		return (EAttribute)tokenEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getToken_Position() {
		return (EReference)tokenEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFinishedNotification() {
		return finishedNotificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFinishedNotification_Winners() {
		return (EReference)finishedNotificationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFinishedNotification_Reason() {
		return (EAttribute)finishedNotificationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConfiguration() {
		return configurationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConfiguration_FieldWidth() {
		return (EAttribute)configurationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConfiguration_RoundTimeAI() {
		return (EAttribute)configurationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConfiguration_RoundTimePlayer() {
		return (EAttribute)configurationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConfiguration_PresentationTime() {
		return (EAttribute)configurationEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConfiguration_PlayerCount() {
		return (EAttribute)configurationEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConfiguration_TilesDistList() {
		return (EAttribute)configurationEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getConfiguration_NotPlayableFields() {
		return (EReference)configurationEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGame() {
		return gameEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGame_Configuration() {
		return (EReference)gameEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGame_State() {
		return (EAttribute)gameEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGame_GameId() {
		return (EAttribute)gameEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGame_Name() {
		return (EAttribute)gameEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGame_PlayerList() {
		return (EReference)gameEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSetTileCmd() {
		return setTileCmdEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSetTileCmd_Placement() {
		return (EReference)setTileCmdEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGameListRequest() {
		return gameListRequestEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGameListResponse() {
		return gameListResponseEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGameListResponse_Games() {
		return (EReference)gameListResponseEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGameJoinRequest() {
		return gameJoinRequestEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGameJoinRequest_Name() {
		return (EAttribute)gameJoinRequestEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGameJoinRequest_Role() {
		return (EAttribute)gameJoinRequestEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGameJoinRequest_GameId() {
		return (EAttribute)gameJoinRequestEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGameStartNotification() {
		return gameStartNotificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGameStartNotification_Game() {
		return (EReference)gameStartNotificationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGamePauseNotification() {
		return gamePauseNotificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGameContinueNotification() {
		return gameContinueNotificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPlacement() {
		return placementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPlacement_Rotation() {
		return (EAttribute)placementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPlacement_Tile() {
		return (EReference)placementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPlacement_Destination() {
		return (EReference)placementEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProcessingRequestReply() {
		return processingRequestReplyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProcessingRequestReply_Response() {
		return (EAttribute)processingRequestReplyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProcessingRequestReply_ClientId() {
		return (EAttribute)processingRequestReplyEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getKickReason() {
		return kickReasonEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getRotation() {
		return rotationEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getFinishedReason() {
		return finishedReasonEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getGate() {
		return gateEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getGameState() {
		return gameStateEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getClientRole() {
		return clientRoleEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getJoinResponse() {
		return joinResponseEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Tsuro_InterfaceFactory getTsuro_InterfaceFactory() {
		return (Tsuro_InterfaceFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		turnNotificationEClass = createEClass(TURN_NOTIFICATION);
		createEAttribute(turnNotificationEClass, TURN_NOTIFICATION__SET_TOKEN);
		createEReference(turnNotificationEClass, TURN_NOTIFICATION__PLAYER);

		kickNotificationEClass = createEClass(KICK_NOTIFICATION);
		createEAttribute(kickNotificationEClass, KICK_NOTIFICATION__REASON);
		createEReference(kickNotificationEClass, KICK_NOTIFICATION__PLAYERS);

		gameStateNotificationEClass = createEClass(GAME_STATE_NOTIFICATION);
		createEReference(gameStateNotificationEClass, GAME_STATE_NOTIFICATION__TURN_PLAYER);
		createEAttribute(gameStateNotificationEClass, GAME_STATE_NOTIFICATION__CURRENT_ROUND_NO);
		createEAttribute(gameStateNotificationEClass, GAME_STATE_NOTIFICATION__TIME_PASSED);
		createEReference(gameStateNotificationEClass, GAME_STATE_NOTIFICATION__GAME);
		createEReference(gameStateNotificationEClass, GAME_STATE_NOTIFICATION__NEXT_TILE_POSITION);
		createEReference(gameStateNotificationEClass, GAME_STATE_NOTIFICATION__PLACEMENTS);

		positionEClass = createEClass(POSITION);
		createEAttribute(positionEClass, POSITION__X);
		createEAttribute(positionEClass, POSITION__Y);

		tileEClass = createEClass(TILE);
		createEAttribute(tileEClass, TILE__TILE_ID);

		playerEClass = createEClass(PLAYER);
		createEAttribute(playerEClass, PLAYER__NAME);
		createEAttribute(playerEClass, PLAYER__IS_AI);
		createEReference(playerEClass, PLAYER__POSITION);
		createEAttribute(playerEClass, PLAYER__CLIENT_ID);
		createEReference(playerEClass, PLAYER__TILE_LIST);
		createEAttribute(playerEClass, PLAYER__IN_GAME);

		setTokenCmdEClass = createEClass(SET_TOKEN_CMD);
		createEAttribute(setTokenCmdEClass, SET_TOKEN_CMD__GATE);

		tokenEClass = createEClass(TOKEN);
		createEAttribute(tokenEClass, TOKEN__GATE);
		createEReference(tokenEClass, TOKEN__POSITION);

		finishedNotificationEClass = createEClass(FINISHED_NOTIFICATION);
		createEReference(finishedNotificationEClass, FINISHED_NOTIFICATION__WINNERS);
		createEAttribute(finishedNotificationEClass, FINISHED_NOTIFICATION__REASON);

		configurationEClass = createEClass(CONFIGURATION);
		createEAttribute(configurationEClass, CONFIGURATION__FIELD_WIDTH);
		createEAttribute(configurationEClass, CONFIGURATION__ROUND_TIME_AI);
		createEAttribute(configurationEClass, CONFIGURATION__ROUND_TIME_PLAYER);
		createEAttribute(configurationEClass, CONFIGURATION__PRESENTATION_TIME);
		createEAttribute(configurationEClass, CONFIGURATION__PLAYER_COUNT);
		createEAttribute(configurationEClass, CONFIGURATION__TILES_DIST_LIST);
		createEReference(configurationEClass, CONFIGURATION__NOT_PLAYABLE_FIELDS);

		gameEClass = createEClass(GAME);
		createEReference(gameEClass, GAME__CONFIGURATION);
		createEAttribute(gameEClass, GAME__STATE);
		createEAttribute(gameEClass, GAME__GAME_ID);
		createEAttribute(gameEClass, GAME__NAME);
		createEReference(gameEClass, GAME__PLAYER_LIST);

		setTileCmdEClass = createEClass(SET_TILE_CMD);
		createEReference(setTileCmdEClass, SET_TILE_CMD__PLACEMENT);

		gameListRequestEClass = createEClass(GAME_LIST_REQUEST);

		gameListResponseEClass = createEClass(GAME_LIST_RESPONSE);
		createEReference(gameListResponseEClass, GAME_LIST_RESPONSE__GAMES);

		gameJoinRequestEClass = createEClass(GAME_JOIN_REQUEST);
		createEAttribute(gameJoinRequestEClass, GAME_JOIN_REQUEST__NAME);
		createEAttribute(gameJoinRequestEClass, GAME_JOIN_REQUEST__ROLE);
		createEAttribute(gameJoinRequestEClass, GAME_JOIN_REQUEST__GAME_ID);

		gameStartNotificationEClass = createEClass(GAME_START_NOTIFICATION);
		createEReference(gameStartNotificationEClass, GAME_START_NOTIFICATION__GAME);

		gamePauseNotificationEClass = createEClass(GAME_PAUSE_NOTIFICATION);

		gameContinueNotificationEClass = createEClass(GAME_CONTINUE_NOTIFICATION);

		placementEClass = createEClass(PLACEMENT);
		createEAttribute(placementEClass, PLACEMENT__ROTATION);
		createEReference(placementEClass, PLACEMENT__TILE);
		createEReference(placementEClass, PLACEMENT__DESTINATION);

		processingRequestReplyEClass = createEClass(PROCESSING_REQUEST_REPLY);
		createEAttribute(processingRequestReplyEClass, PROCESSING_REQUEST_REPLY__RESPONSE);
		createEAttribute(processingRequestReplyEClass, PROCESSING_REQUEST_REPLY__CLIENT_ID);

		// Create enums
		kickReasonEEnum = createEEnum(KICK_REASON);
		rotationEEnum = createEEnum(ROTATION);
		finishedReasonEEnum = createEEnum(FINISHED_REASON);
		gateEEnum = createEEnum(GATE);
		gameStateEEnum = createEEnum(GAME_STATE);
		clientRoleEEnum = createEEnum(CLIENT_ROLE);
		joinResponseEEnum = createEEnum(JOIN_RESPONSE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		XMLTypePackage theXMLTypePackage = (XMLTypePackage)EPackage.Registry.INSTANCE.getEPackage(XMLTypePackage.eNS_URI);

		// Add supertypes to classes

		// Initialize classes and features; add operations and parameters
		initEClass(turnNotificationEClass, TurnNotification.class, "TurnNotification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTurnNotification_SetToken(), ecorePackage.getEBoolean(), "setToken", "false", 1, 1, TurnNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTurnNotification_Player(), this.getPlayer(), null, "player", null, 1, 1, TurnNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(kickNotificationEClass, KickNotification.class, "KickNotification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getKickNotification_Reason(), this.getKickReason(), "reason", null, 1, 1, KickNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getKickNotification_Players(), this.getPlayer(), null, "players", null, 1, 4, KickNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(gameStateNotificationEClass, GameStateNotification.class, "GameStateNotification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getGameStateNotification_TurnPlayer(), this.getPlayer(), null, "turnPlayer", null, 0, 1, GameStateNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGameStateNotification_CurrentRoundNo(), ecorePackage.getEInt(), "currentRoundNo", null, 1, 1, GameStateNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGameStateNotification_TimePassed(), ecorePackage.getEInt(), "timePassed", null, 1, 1, GameStateNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getGameStateNotification_Game(), this.getGame(), null, "game", null, 1, 1, GameStateNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getGameStateNotification_NextTilePosition(), this.getPosition(), null, "nextTilePosition", null, 0, 1, GameStateNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getGameStateNotification_Placements(), this.getPlacement(), null, "placements", null, 0, -1, GameStateNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(positionEClass, Position.class, "Position", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPosition_X(), ecorePackage.getEInt(), "x", null, 1, 1, Position.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPosition_Y(), ecorePackage.getEInt(), "y", null, 1, 1, Position.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(tileEClass, Tile.class, "Tile", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTile_TileId(), ecorePackage.getEInt(), "tileId", null, 1, 1, Tile.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(playerEClass, Player.class, "Player", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPlayer_Name(), ecorePackage.getEString(), "name", null, 1, 1, Player.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPlayer_IsAI(), theXMLTypePackage.getBoolean(), "isAI", null, 1, 1, Player.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPlayer_Position(), this.getToken(), null, "position", null, 0, 1, Player.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPlayer_ClientId(), ecorePackage.getEInt(), "clientId", null, 1, 1, Player.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPlayer_TileList(), this.getTile(), null, "tileList", null, 0, -1, Player.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPlayer_InGame(), ecorePackage.getEBoolean(), "inGame", "true", 1, 1, Player.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(setTokenCmdEClass, SetTokenCmd.class, "SetTokenCmd", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSetTokenCmd_Gate(), this.getGate(), "gate", null, 1, 1, SetTokenCmd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(tokenEClass, Token.class, "Token", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getToken_Gate(), this.getGate(), "gate", null, 1, 1, Token.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getToken_Position(), this.getPosition(), null, "position", null, 1, 1, Token.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(finishedNotificationEClass, FinishedNotification.class, "FinishedNotification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getFinishedNotification_Winners(), this.getPlayer(), null, "winners", null, 0, 4, FinishedNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFinishedNotification_Reason(), this.getFinishedReason(), "reason", null, 1, 1, FinishedNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(configurationEClass, Configuration.class, "Configuration", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getConfiguration_FieldWidth(), ecorePackage.getEInt(), "fieldWidth", "7", 1, 1, Configuration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getConfiguration_RoundTimeAI(), ecorePackage.getEInt(), "roundTimeAI", "-1", 1, 1, Configuration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConfiguration_RoundTimePlayer(), ecorePackage.getEInt(), "roundTimePlayer", "-1", 1, 1, Configuration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConfiguration_PresentationTime(), ecorePackage.getEInt(), "presentationTime", null, 1, 1, Configuration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConfiguration_PlayerCount(), ecorePackage.getEInt(), "playerCount", null, 1, 1, Configuration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConfiguration_TilesDistList(), ecorePackage.getEInt(), "tilesDistList", null, 35, 35, Configuration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getConfiguration_NotPlayableFields(), this.getPosition(), null, "notPlayableFields", null, 0, -1, Configuration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(gameEClass, Game.class, "Game", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getGame_Configuration(), this.getConfiguration(), null, "configuration", null, 1, 1, Game.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGame_State(), this.getGameState(), "state", null, 1, 1, Game.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGame_GameId(), ecorePackage.getEInt(), "gameId", null, 1, 1, Game.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGame_Name(), ecorePackage.getEString(), "name", null, 1, 1, Game.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getGame_PlayerList(), this.getPlayer(), null, "playerList", null, 0, 4, Game.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(setTileCmdEClass, SetTileCmd.class, "SetTileCmd", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSetTileCmd_Placement(), this.getPlacement(), null, "placement", null, 1, 1, SetTileCmd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(gameListRequestEClass, GameListRequest.class, "GameListRequest", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(gameListResponseEClass, GameListResponse.class, "GameListResponse", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getGameListResponse_Games(), this.getGame(), null, "games", null, 0, -1, GameListResponse.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(gameJoinRequestEClass, GameJoinRequest.class, "GameJoinRequest", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getGameJoinRequest_Name(), ecorePackage.getEString(), "name", null, 1, 1, GameJoinRequest.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGameJoinRequest_Role(), this.getClientRole(), "role", "SPECTATOR", 1, 1, GameJoinRequest.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGameJoinRequest_GameId(), ecorePackage.getEInt(), "gameId", "-1", 1, 1, GameJoinRequest.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(gameStartNotificationEClass, GameStartNotification.class, "GameStartNotification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getGameStartNotification_Game(), this.getGame(), null, "game", null, 1, 1, GameStartNotification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(gamePauseNotificationEClass, GamePauseNotification.class, "GamePauseNotification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(gameContinueNotificationEClass, GameContinueNotification.class, "GameContinueNotification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(placementEClass, Placement.class, "Placement", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPlacement_Rotation(), this.getRotation(), "rotation", null, 1, 1, Placement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPlacement_Tile(), this.getTile(), null, "tile", null, 1, 1, Placement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPlacement_Destination(), this.getPosition(), null, "destination", null, 1, 1, Placement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(processingRequestReplyEClass, ProcessingRequestReply.class, "ProcessingRequestReply", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getProcessingRequestReply_Response(), this.getJoinResponse(), "response", "JOINED_QUEUE", 1, 1, ProcessingRequestReply.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProcessingRequestReply_ClientId(), ecorePackage.getEInt(), "clientId", null, 1, 1, ProcessingRequestReply.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(kickReasonEEnum, KickReason.class, "KickReason");
		addEEnumLiteral(kickReasonEEnum, KickReason.DEFAULT_LITERAL);
		addEEnumLiteral(kickReasonEEnum, KickReason.INVALID_TILE_LITERAL);
		addEEnumLiteral(kickReasonEEnum, KickReason.TILE_NOT_OWNED_LITERAL);
		addEEnumLiteral(kickReasonEEnum, KickReason.TIMEOUT_LITERAL);
		addEEnumLiteral(kickReasonEEnum, KickReason.INVALID_GATE_LITERAL);
		addEEnumLiteral(kickReasonEEnum, KickReason.INVALID_REQUEST_LITERAL);
		addEEnumLiteral(kickReasonEEnum, KickReason.INVALID_TILE_POSITION_LITERAL);
		addEEnumLiteral(kickReasonEEnum, KickReason.CONNECTION_LOST_LITERAL);

		initEEnum(rotationEEnum, Rotation.class, "Rotation");
		addEEnumLiteral(rotationEEnum, Rotation.NORTH_LITERAL);
		addEEnumLiteral(rotationEEnum, Rotation.EAST_LITERAL);
		addEEnumLiteral(rotationEEnum, Rotation.SOUTH_LITERAL);
		addEEnumLiteral(rotationEEnum, Rotation.WEST_LITERAL);

		initEEnum(finishedReasonEEnum, FinishedReason.class, "FinishedReason");
		addEEnumLiteral(finishedReasonEEnum, FinishedReason.DEFAULT_LITERAL);
		addEEnumLiteral(finishedReasonEEnum, FinishedReason.LAST_ONE_STANDING_LITERAL);
		addEEnumLiteral(finishedReasonEEnum, FinishedReason.EVERYBODY_DIED_LITERAL);
		addEEnumLiteral(finishedReasonEEnum, FinishedReason.ABORT_LITERAL);

		initEEnum(gateEEnum, Gate.class, "Gate");
		addEEnumLiteral(gateEEnum, Gate.NORTH_LEFT_LITERAL);
		addEEnumLiteral(gateEEnum, Gate.NORTH_RIGHT_LITERAL);
		addEEnumLiteral(gateEEnum, Gate.WEST_UPPER_LITERAL);
		addEEnumLiteral(gateEEnum, Gate.WEST_LOWER_LITERAL);
		addEEnumLiteral(gateEEnum, Gate.SOUTH_RIGHT_LITERAL);
		addEEnumLiteral(gateEEnum, Gate.SOUTH_LEFT_LITERAL);
		addEEnumLiteral(gateEEnum, Gate.EAST_LOWER_LITERAL);
		addEEnumLiteral(gateEEnum, Gate.EAST_UPPER_LITERAL);

		initEEnum(gameStateEEnum, GameState.class, "GameState");
		addEEnumLiteral(gameStateEEnum, GameState.NOT_STARTED_LITERAL);
		addEEnumLiteral(gameStateEEnum, GameState.RUNNING_LITERAL);
		addEEnumLiteral(gameStateEEnum, GameState.PAUSED_LITERAL);

		initEEnum(clientRoleEEnum, ClientRole.class, "ClientRole");
		addEEnumLiteral(clientRoleEEnum, ClientRole.PLAYER_LITERAL);
		addEEnumLiteral(clientRoleEEnum, ClientRole.AI_LITERAL);
		addEEnumLiteral(clientRoleEEnum, ClientRole.SPECTATOR_LITERAL);

		initEEnum(joinResponseEEnum, JoinResponse.class, "JoinResponse");
		addEEnumLiteral(joinResponseEEnum, JoinResponse.SUCCESS_LITERAL);
		addEEnumLiteral(joinResponseEEnum, JoinResponse.GAME_FULL_LITERAL);
		addEEnumLiteral(joinResponseEEnum, JoinResponse.NON_EXISTING_LITERAL);
		addEEnumLiteral(joinResponseEEnum, JoinResponse.RUNNING_LITERAL);
		addEEnumLiteral(joinResponseEEnum, JoinResponse.FAILED_LITERAL);
		addEEnumLiteral(joinResponseEEnum, JoinResponse.NAME_TAKEN_LITERAL);
		addEEnumLiteral(joinResponseEEnum, JoinResponse.DENIED_LITERAL);
		addEEnumLiteral(joinResponseEEnum, JoinResponse.JOINED_QUEUE_LITERAL);
		addEEnumLiteral(joinResponseEEnum, JoinResponse.PENDING_APPROVAL_LITERAL);

		// Create resource
		createResource(eNS_URI);
	}

} //Tsuro_InterfacePackageImpl
